package nd.seniordesign;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.List;

import android.app.Activity;
import android.content.Intent;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.MenuItem.OnMenuItemClickListener;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.Gallery;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;



public class SmartWindows extends Activity implements OnClickListener {

	//********************** CONSTANTS **********************
	public int WIN_1 = 1;
	public int WIN_2 = 2;
	public int MY_OPEN = -1;
	public int MY_MIDDLE = 0;
	public int MY_CLOSE = 1;

	public String WIN_1_ID   = "1267301014";
	public String WIN_2_ID   = "1267369485";
	public String CMD_OPEN   = "&rating=-1";
	public String CMD_MIDDLE = "&rating=0";
	public String CMD_CLOSE  = "&rating=1";
	public String CMD_CORE   = "http://129.74.154.171/observer/submit_rating.php?skey=041a09cd46ac0093246c8917-5619109&uid=5619109&mid=";

	public String COMP_CMD_OPEN_WIN_1   = CMD_CORE + WIN_1_ID + CMD_OPEN;
	public String COMP_CMD_MIDDLE_WIN_1 = CMD_CORE + WIN_1_ID + CMD_MIDDLE;
	public String COMP_CMD_CLOSE_WIN_1  = CMD_CORE + WIN_1_ID + CMD_CLOSE;
	public String COMP_CMD_OPEN_WIN_2   = CMD_CORE + WIN_2_ID + CMD_OPEN;
	public String COMP_CMD_MIDDLE_WIN_2 = CMD_CORE + WIN_2_ID + CMD_MIDDLE;
	public String COMP_CMD_CLOSE_WIN_2  = CMD_CORE + WIN_2_ID + CMD_CLOSE;
	//*********************************************************
	
	Button oButton 			= null;
	Button mButton 			= null;
	Button cButton 			= null;
	TextView win_name_label = null;
	
	//Set on menu item click
	public int 		currentWindow 	= 1;
	public int		currentCommand 	= -1;
	//Set after button click, before Async task begins
	public String 	currentUrlStr 	= "";
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.window_1_xml);
        
        win_name_label = (TextView) this.findViewById(R.id.windowNameLabel);
        win_name_label.setTextSize((float) 26.0);
        
        oButton = (Button) this.findViewById(R.id.openButton);
        mButton = (Button) this.findViewById(R.id.middleButton);
        cButton = (Button) this.findViewById(R.id.closeButton);
        
        oButton.setTag("openButton");
        mButton.setTag("middleButton");
        cButton.setTag("closeButton");
        
        oButton.setOnClickListener(this);
        mButton.setOnClickListener(this);
        cButton.setOnClickListener(this);
    }

	@Override
	public void onClick(View v) {
		if(v.getTag().toString().contains("open")) {
			this.currentCommand = -1;
			new async0().execute("");
			Toast t = Toast.makeText(this, "Open command sending...", Toast.LENGTH_SHORT);
			t.show();
		}else if(v.getTag().toString().contains("middle")) {
			this.currentCommand = 0;
			new async0().execute("");
			Toast t = Toast.makeText(this, "Middle command sending...", Toast.LENGTH_SHORT);
			t.show();
		}else if(v.getTag().toString().contains("close")) {
			this.currentCommand = 1;
			new async0().execute("");
			Toast t = Toast.makeText(this, "Close command sending...", Toast.LENGTH_SHORT);
			t.show();	
		}
	}
    
    
    //******************* URL get (within AsyncTask wrapper) *****************
	public class async0 extends AsyncTask<String, String, String> {
		
		URL url = null;
		HttpURLConnection urlConn = null;
		InputStreamReader isr = null;
		BufferedReader in = null;
		String inputLine = null;
		boolean epicFail = false;
		
		protected void onPreExecute() {
		
			if((SmartWindows.this.currentCommand == -1) && (SmartWindows.this.currentWindow == 1))
				SmartWindows.this.currentUrlStr = COMP_CMD_OPEN_WIN_1;
			else if((SmartWindows.this.currentCommand == 0) && (SmartWindows.this.currentWindow == 1))
				SmartWindows.this.currentUrlStr = COMP_CMD_MIDDLE_WIN_1;
			else if((SmartWindows.this.currentCommand == 1) && (SmartWindows.this.currentWindow == 1))
				SmartWindows.this.currentUrlStr = COMP_CMD_CLOSE_WIN_1;
			else if((SmartWindows.this.currentCommand == -1) && (SmartWindows.this.currentWindow == 2))
				SmartWindows.this.currentUrlStr = COMP_CMD_OPEN_WIN_2;	
			else if((SmartWindows.this.currentCommand == 0) && (SmartWindows.this.currentWindow == 2))
				SmartWindows.this.currentUrlStr = COMP_CMD_MIDDLE_WIN_2;
			else if((SmartWindows.this.currentCommand == 1) && (SmartWindows.this.currentWindow == 2))
				SmartWindows.this.currentUrlStr = COMP_CMD_CLOSE_WIN_2;
			
			super.onPreExecute();
		}
		
		protected String doInBackground(String... params) {
			try {
				url 		= new URL(SmartWindows.this.currentUrlStr);
				urlConn 	= (HttpURLConnection) url.openConnection();
				isr 		= new InputStreamReader(urlConn.getInputStream());
				in 			= new BufferedReader(isr);
				inputLine 	= in.readLine();
				in.close();
				urlConn.disconnect();
			}catch(Exception e3) {
				Log.v("ANDY", "exception 3");
			}	
			return ""; 
		}
		
		protected void onPostExecute(String result) {
			String msg;
			if(epicFail) {
				msg = "Failed to deliver command, sorry";
			}else {
				msg = "Sent!";
			}
			Toast t = Toast.makeText(SmartWindows.this, msg, Toast.LENGTH_SHORT);
			t.show();
			super.onPostExecute(result);
		}
	}

	//****************************** MENU *********************************
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.layout.menu_all_media, menu);

		MenuItem  menu_item_win_1 = menu.getItem(0);
		MenuItem  menu_item_win_2 = menu.getItem(1);
		
		menu_item_win_1.setOnMenuItemClickListener(new OnMenuItemClickListener() {
			@Override
			public boolean onMenuItemClick(MenuItem item) {
				if(SmartWindows.this.win_name_label != null) {
					if(currentWindow == 1) { //if we're already on win 1
						Toast t = Toast.makeText(SmartWindows.this, "Already set to window 1", Toast.LENGTH_SHORT);
						t.show();
					}
					else {
						SmartWindows.this.win_name_label.setText("Window 1");
						currentWindow = 1;
						Toast t = Toast.makeText(SmartWindows.this, "Now set to window 1", Toast.LENGTH_SHORT);
						t.show();
					}
				}
				return true; 
			}
		});
		
		menu_item_win_2.setOnMenuItemClickListener(new OnMenuItemClickListener() {
			@Override
			public boolean onMenuItemClick(MenuItem item) {
				if(SmartWindows.this.win_name_label != null) {
					if(currentWindow == 2) { //if we're already on win 2
						Toast t = Toast.makeText(SmartWindows.this, "Already set to window 2", Toast.LENGTH_SHORT);
						t.show();
					}
					else {
						SmartWindows.this.win_name_label.setText("Window 2");
						currentWindow = 2;
						Toast t = Toast.makeText(SmartWindows.this, "Now set to window 2", Toast.LENGTH_SHORT);
						t.show();
					}
				}
				return true; 
			}
		});
		return true;
	}
	
}




