from __future__ import division
import sys
import time
import os
import platform
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from PyQt4.uic import *
from math import *
#My classes:
from SingleWindow import *
from SendToMicro import *
from RigUp import *
#Multithreading:
from multiprocessing import Process, Lock, Value, Array, Pipe

class AllWindows(QMainWindow): #QWidget):
#    def setMyTitle(self, xxxx):
#        self.setWindowTitle(xxxx)    

###########################################
############ NEW BUTTON STUFF #############
###########################################
#    Commands().sendSimpleCommand(windowNumber, cmd_open, cmd_middle, cmd_close, cmd_green, cmd_security)

    def myShowMsg(self, msg):
        qq = QMessageBox()
        qq.setText(msg)
        qq.setWindowTitle("Update!")
        qq.exec_()  
    def handleAutoModeClick(self, n):
        Commands().sendSimpleCommand(windowNumber=n, cmd_security=True)
        self.myShowMsg("Window " + str(n) + " is now in timing mode!")
    def handleManualModeClick(self, n):
        print "manual mode click for window " + str(n)
    def handleEcoModeClick(self, n):
        Commands().sendSimpleCommand(windowNumber=n, cmd_green=True)
        self.myShowMsg("Window " + str(n) + " is now in eco mode!")
    def handleOpenModeClick(self, n):
        Commands().sendSimpleCommand(windowNumber=n, cmd_open=True)
        self.myShowMsg("Window " + str(n) + " is now opening!")
    def handleHalfModeClick(self, n):
        Commands().sendSimpleCommand(windowNumber=n, cmd_middle=True)
        self.myShowMsg("Window " + str(n) + " is now going to the middle!")
    def handleCloseModeClick(self, n):
        Commands().sendSimpleCommand(windowNumber=n, cmd_close=True)
        self.myShowMsg("Window " + str(n) + " is now closing!")
    def modeClickHandler(self, obName, myInstance):
        me     = obName + str(myInstance)
        notme  = []
        if(obName.count('auto') < 1):
            notme.append('autoButton' + str(myInstance))
        else:
            self.handleAutoModeClick(myInstance)
        if(obName.count('manual') < 1):
            notme.append('manualButton' + str(myInstance))
        else:
            self.handleManualModeClick(myInstance)
        if(obName.count('eco') < 1):
            notme.append('ecoButton' + str(myInstance))
        else:
            self.handleEcoModeClick(myInstance)
        qpb = self.findChild(QPushButton, name=me)
        qpb2 = self.findChild(QPushButton, name=notme[0])
        qpb3 = self.findChild(QPushButton, name=notme[1])
        qpb.setIcon(QIcon(obName + 'X.png'))
        qpb2.setIcon(QIcon(notme[0][0:-1] + '.png'))
        qpb3.setIcon(QIcon(notme[1][0:-1] + '.png'))
        shouldEnable = (obName.count('manual') > 0) 
        temp1 = self.findChild(QPushButton, name="open" + str(myInstance))
        temp1.setEnabled(shouldEnable)
        temp2 = self.findChild(QPushButton, name="half" + str(myInstance))
        temp2.setEnabled(shouldEnable)
        temp3 = self.findChild(QPushButton, name="close" + str(myInstance))
        temp3.setEnabled(shouldEnable)
        
    def modeClickHandler2(self, obName, myInstance):
        me     = obName + str(myInstance)
        notme  = []
        if(obName.count('open') < 1):
            notme.append('open' + str(myInstance))
        else:
            self.handleOpenModeClick(myInstance)
        if(obName.count('half') < 1):
            notme.append('half' + str(myInstance))
        else:
            self.handleHalfModeClick(myInstance)
        if(obName.count('close') < 1):
            notme.append('close' + str(myInstance))
        else:
            self.handleCloseModeClick(myInstance)
        qpb = self.findChild(QPushButton, name=me)
        qpb2 = self.findChild(QPushButton, name=notme[0])
        qpb3 = self.findChild(QPushButton, name=notme[1])
        qpb.setIcon(QIcon(obName + 'X.png'))
        qpb2.setIcon(QIcon(notme[0][0:-1] + '.png'))
        qpb3.setIcon(QIcon(notme[1][0:-1] + '.png'))

    def createMyButton(self, objName, myInstance):
        modeButton = QPushButton()    
        modeButton.setIcon(QIcon(objName + '.png'))
        if(objName.count('auto')>0): #START OUT IN AUTO MODE
            modeButton.setIcon(QIcon(objName + 'X.png'))            
        modeButton.setIconSize(QSize(50,50)) #70
        modeButton.setObjectName(objName + str(myInstance))
        def miniClickHandle():
            self.modeClickHandler(objName, myInstance)
        self.connect(modeButton, SIGNAL("clicked()"), miniClickHandle)
        return modeButton
    
    def createMyButton2(self, objName, myInstance):
        modeButton = QPushButton()
        modeButton.setEnabled(False)
        modeButton.setIcon(QIcon(objName + '.png'))
        modeButton.setIconSize(QSize(50,50)) #70
        modeButton.setObjectName(objName + str(myInstance))
        def miniClickHandle():
            self.modeClickHandler2(objName, myInstance)
        self.connect(modeButton, SIGNAL("clicked()"), miniClickHandle)
        return modeButton
    
    def makeWholeVlayoutButtonSet(self, myInstance):
        vlayout = QVBoxLayout()
        hlayout = QHBoxLayout()        
        hlayout.addWidget(self.createMyButton('autoButton', myInstance))
        hlayout.addWidget(self.createMyButton('manualButton', myInstance))
        hlayout.addWidget(self.createMyButton('ecoButton', myInstance))
        hlayout2 = QHBoxLayout()
        hlayout2.addWidget(self.createMyButton2('open', myInstance))
        hlayout2.addWidget(self.createMyButton2('half', myInstance))
        hlayout2.addWidget(self.createMyButton2('close', myInstance))
        vlayout.addLayout(hlayout)
        vlayout.addLayout(hlayout2)
        return vlayout

###########################################
###########################################
###########################################

    def pullDescriptionFromFile(self, myFile):
        if os.path.exists(myFile) == False: #if something went wrong
            return "(None)"
        with open(myFile,"r") as f:
            lns = f.read()
            f.close()
        lns = lns.split("\n")
        if(len(lns) > 1):
            return str(lns[0])
        return "(None)"
    def reloadNames(self):
        print "reloadNames"
        f_list = []
#        for f in os.listdir(os.getcwd()):
#            if str(f).split('.')[1] == "settings":
#                f_list.append(f)
#        for i_f in range(len(f_list)):
#            with open(f_list[i_f],"r") as f:
#                linez = f.read()
#                f.close()
#            linez = linez.split("\n")
#            if(len(linez) > 1):
#                myTempTitle = str(linez[0])
#            self.findChild(QLabel, "myLabel_" + str(i_f)).setText(myTempTitle)
    def myClickHandler(self):
        for z in range(self.myNumberOfButtons):
            if self.findChild(QPushButton, QString("myWindowButtons_"+str(z))) == self.focusWidget():
                f2 = SingleWindow(winID = self.listOfWindowIDs[z])
                f2.show()
                #self.connect(self.visibleRegion(), SIGNAL("clicked()"), self.reloadNames)
                return        
    def __init__(self, parent=None, i_am_reloading=False, refresh_text=' '):
        #################################################
        ws = Commands().setup()
        RigUp().matchSettingFiles(ws)
        light_readings = Commands().getLightSensorReadings()
        #################################################
        if(i_am_reloading == False):        
            super(AllWindows, self).__init__(parent)
            self.setWindowTitle("SmartWindows! Click a window to change manual time settings...")
            self.resize(QSize(600,200))
            self.addMyMenuBar()
        bigvlayout = QVBoxLayout()
        hlayout = QHBoxLayout()
        hlayout.setObjectName("myVLayout")
        listOfSettingsFiles = []        
        listOfWindowIDs = []
        listOfWindowNames = []        
        for f in os.listdir(os.getcwd()):
            if str(f).split('.')[1] == "settings":
                listOfSettingsFiles.append(f)
                listOfWindowIDs.append(str(f).split('.')[0])
                listOfWindowNames.append(self.pullDescriptionFromFile(f))
        myWindowTuple = zip(listOfSettingsFiles, listOfWindowIDs, listOfWindowNames)
        self.myNumberOfButtons = len(listOfSettingsFiles)
        self.listOfWindowIDs = listOfWindowIDs #save this for later (in click handler)
        ############ If we have no windows #############
        if(len(myWindowTuple) == 0):
            myButton = QPushButton()
            myButton.setIcon(QIcon("no_windows.jpg"))
            myButton.setIconSize(QSize(500,312))
            hlayout.addWidget(myButton)
        ################################################
        #"getLightSensorReadings" returns light sensor 0, battery sensor 0, light sensor 1, battery sensor 1, etc....
        for mwt in range(len(myWindowTuple)):
            miniVerticalLayout = QVBoxLayout()
            myButton = QPushButton()
            myButton.setIcon(QIcon("windowPic.png"))
            myButton.setIconSize(QSize(170,170)) #was 150,150
            myButton.setObjectName("myWindowButtons_"+str(mwt))
            self.connect(myButton, SIGNAL("clicked()"), self.myClickHandler)
            myLabel = QLabel()
            myLabel.setObjectName("myLabel_" + str(mwt)) #36 / 48 / 60
            myLabel.setFont(QFont("ChopinScript")) #########################
            myLabel.setText("<font size=\"48\">" + ws[mwt] + "</font>")
            myLabel.setAlignment(Qt.AlignHCenter)
            # Light readout... #
            myLabel2 = QLabel()
            myLabel2.setObjectName("light_" + str(mwt)) #36 / 48 / 60
            myD = 1.0*light_readings[2*mwt] #i just made a variable called my D. lolz. it stands for double tho.
            myD = 100.*myD/255.
            myLabel2.setText("<font color=\"green\"><h3>Light: " + str(myD)[0:4] + "%" + "</h3></font>")
            myLabel2.setAlignment(Qt.AlignHCenter)
            # Battery readout... #
            myLabel3 = QLabel()
            myLabel3.setObjectName("battery_" + str(mwt)) #36 / 48 / 60
            myD2 = 1.0*light_readings[2*mwt+1] #i just made a variable called my D. lolz. it stands for double tho.
            myD2 = 100.*myD2/170.                        
            cut_off = 75;
            if(myD2 > cut_off):
                myLabel3.setText("<font color=\"blue\"><h3>Battery: " + (str(myD2) + "    ")[0:4] + "% (Ok)" + "</h3></font>")
            else:
                myLabel3.setText("<font color=\"blue\"><h3>Battery: " + (str(myD2) + "    ")[0:4] + "%<font color=\"red\"> (LOW!)</font>" + "</h3></font>")
            myLabel3.setAlignment(Qt.AlignHCenter)
            #####################
            miniVerticalLayout.addWidget(myLabel)            
            miniVerticalLayout.addWidget(myButton)
            miniVerticalLayout.addWidget(myLabel2)
            miniVerticalLayout.addWidget(myLabel3)
            miniVerticalLayout.addLayout(self.makeWholeVlayoutButtonSet(mwt)) #BUTTONS
            #///////////// add border ?
            hlayout.addItem(miniVerticalLayout)
        qw = QWidget()
        ################
        bigvlayout.addLayout(hlayout)
        refreshButton = QPushButton()
        refreshButton.setBaseSize(100, 100)
        refreshButton.setIcon(QIcon("refresh2.png"))
        refreshButton.setIconSize(QSize(100,100))
        myLabel2 = QLabel()
        myLabel2.setFont(QFont("ChopinScript"))
        myLabel2.setText("<font size=\"48\">Refresh</font>")
        myLabel2.setAlignment(Qt.AlignHCenter)
        myLabel2.setObjectName("refreshLabel")
        bigvlayout.addWidget(myLabel2)
        refLabel = QLabel()
        refLabel.setAlignment(Qt.AlignHCenter)
        refLabel.setText(refresh_text)
        bigvlayout.addWidget(refLabel)
        bigvlayout.addWidget(refreshButton)
        def refreshClickHandle():
            xxyy = "<h4>" + time.asctime() + "</h4>"
            self.__init__(parent, i_am_reloading=True, refresh_text=xxyy)
        self.connect(refreshButton, SIGNAL("clicked()"), refreshClickHandle)
        qw.setLayout(bigvlayout) #was "qw.setLayout(hlayout)" 
        self.setCentralWidget(qw)
        
    def addMyMenuBar(self):
        #First create all actions:
        quitAction       = self.createAction("&Quit", self.close,"Ctrl+Q", "filequit", "Close the application")
        delWinAction     = self.createAction("&Delete ALL Windows", self.deleteWindowClick,"Ctrl+D", "deletewindow", "Remove a Window")
        #was self.syncTimeClick
        syncTimeAction   = self.createAction("&Sync Module\'s Time", self.sendMyCurrentTime,"Ctrl+S", "synctime", "Synchronize the Time")
        howToUseAction   = self.createAction("&How to Use", self.howToUseClick,"Ctrl+H", "howtouse", "User help content")                
        #Now create all menu categories:
        fileMenu    = self.menuBar().addMenu("&File")
        optionsMenu = self.menuBar().addMenu("&Options")
        helpMenu    = self.menuBar().addMenu("&Help")
        #Now add actions to menu categories:
        fileMenu.addAction(quitAction)
        optionsMenu.addAction(delWinAction)
        optionsMenu.addAction(syncTimeAction)
        helpMenu.addAction(howToUseAction)
    #A helper function:
    def createAction(self, text, slot=None, shortcut=None, icon=None, tip=None, checkable=False, signal="triggered()"):
        action = QAction(text, self)
        if icon is not None:
            action.setIcon(QIcon(":/%s.png" % icon))
        if shortcut is not None:
            action.setShortcut(shortcut)
        if tip is not None:
            action.setToolTip(tip)
            action.setStatusTip(tip)
        if slot is not None:
            self.connect(action, SIGNAL(signal), slot)
        if checkable:
            action.setCheckable(True)
        return action
    def sendMyCurrentTime(self):
        Commands().sendCurrentTime(waitAfter=False)
        qq = QMessageBox()
        qq.setText("Current time set!")
        qq.setWindowTitle("Update!")
        qq.exec_()  
    def deleteWindowClick(self):
        Commands().sendEraseAllWindowsCommand()
        qq = QMessageBox()
        qq.setText("All windows have been removed");
        qq.setWindowTitle("Update!")
        qq.exec_()
    def howToUseClick(self):
        qmb = QMessageBox()
        qmb.setText("<h1><font color=\"blue\">HOW TO USE</font></h1>\n\n\n<img src=\"imconfus.jpg\" width=\"346\" height=\"300\" />")
        qmb.setWindowTitle("Connection")
#        qmb.setIcon(QMessageBox.Warning)
        qmb.addButton(QString("Alright!"), QMessageBox.AcceptRole)
        qmb.addButton(QString("Explains it all!"), QMessageBox.RejectRole)
        qmb.addButton(QString("Terrific!"), QMessageBox.ActionRole)
#        qmb.addButton(QString("Amazing!"), QMessageBox.HelpRole)
        qmb.exec_()
                
                
        