import time
import d2xx

class SendToMicro:
    def send(self, userInput, noisy = False): 
        d = d2xx.listDevices(d2xx.OPEN_BY_DESCRIPTION) # list devices by description, returns tuple
        if(noisy == True):
            print "Devices found: " + str(d)
        try: 
            h = d2xx.open(d.index('FT232R USB UART', )) #get the one we want
            h.setBaudRate(d2xx.BAUD_57600)
            h.setDataCharacteristics(d2xx.BITS_8, d2xx.STOP_BITS_1, d2xx.PARITY_NONE)
            for i in range(len(userInput)):
                h.write(userInput[i])
#                h.read(2)                    
        except ValueError:
            print "Microcontroller not recognized"
    def receive(self, bytesToLookFor = 1, noisy = False):  
        if not isinstance(bytesToLookFor, int):
            print "epic fail"
            return -1
        d = d2xx.listDevices(d2xx.OPEN_BY_DESCRIPTION) # list devices by description, returns tuple
        if(noisy == True):
            print "Devices found: " + str(d)
        try: 
            h = d2xx.open(d.index('FT232R USB UART', )) #get the one we want
            h.setBaudRate(d2xx.BAUD_57600)
            h.setDataCharacteristics(d2xx.BITS_8, d2xx.STOP_BITS_1, d2xx.PARITY_NONE)
#            time.sleep(.01)
            x = h.read(bytesToLookFor)
        except ValueError:
            print "Microcontroller not recognized"
        finally:
            return x
    def microcontrollerIsHookedUp(self):
        d = d2xx.listDevices(d2xx.OPEN_BY_DESCRIPTION) # list devices by description, returns tuple
        try: 
            h = d2xx.open(d.index('FT232R USB UART', )) #get the one we want
            return True                    
        except ValueError:
            return False

class SendToMicroEfficient:
    def setup(self):
        d = d2xx.listDevices(d2xx.OPEN_BY_DESCRIPTION) # list devices by description, returns tuple
        try: 
            self.h = d2xx.open(d.index('FT232R USB UART', )) #get the one we want
            self.h.setBaudRate(d2xx.BAUD_57600)
            self.h.setDataCharacteristics(d2xx.BITS_8, d2xx.STOP_BITS_1, d2xx.PARITY_NONE)
        except ValueError:
            print "EPIC FAIL"
    def send(self, userInput):
#        print str(ord(userInput[0]))       
        for i in range(len(userInput)):
            self.h.write(userInput[i])
    def receive(self, bytes):
        return self.h.read(bytes)