import sys
import time
import os
import platform
import d2xx
#from PyQt4.QtCore import *
from PyQt4.QtCore import Qt
from PyQt4.QtCore import SIGNAL
from PyQt4.QtCore import QSize
from PyQt4.QtCore import QTime
from PyQt4.QtGui import *
from PyQt4.uic import *
from math import *
from Commands import *
from ConvertTimes import *

class SingleWindow(QWidget):
    #---------Get a bit from a number---------
    def getBit(self, num, bitNumFromLeft):
        if bitNumFromLeft == 0:
            return int(bool(num & 0b10000000))
        if bitNumFromLeft == 1:
            return int(bool(num & 0b01000000))
        if bitNumFromLeft == 2:
            return int(bool(num & 0b00100000))
        if bitNumFromLeft == 3:
            return int(bool(num & 0b00010000))
        if bitNumFromLeft == 4:
            return int(bool(num & 0b00001000))
        if bitNumFromLeft == 5:
            return int(bool(num & 0b00000100))
        if bitNumFromLeft == 6:
            return int(bool(num & 0b00000010))
        if bitNumFromLeft == 7:
            return int(bool(num & 0b00000001))
    #--------Get a "day module"---------------
    def getDayModule(self, timestampCounter, whichDay, b0=0, b1=0, b2=0, b3=0, enabled=False): #returns QVBoxLayout of a day
        myMaxHeight = 18
        myMaxWidth = 25
        myMaxWidth2 = 85
        myMaxWidth3 = 65
        dayNamez = ["Enabled","M","T","W","Th","F","Sa","Su","Time","Type","Byte 0","Byte 1","Byte 2","Byte 3"]
        ##################
        dayName = dayNamez[whichDay%(len(dayNamez))]
        ##################
        miniVLayout = QVBoxLayout() #vertical layout
        tempQL = QLabel()
        tempQL.setText(dayName)
        tempQL.setMaximumHeight(myMaxHeight)
        if whichDay == 0: #"enabled"
            x = QCheckBox()
            x.setMaximumHeight(myMaxHeight)
            x.setMinimumWidth(myMaxWidth + 40)
            if(enabled):
                x.setChecked(True)
            else:
                x.setChecked(False)
        if whichDay > 0 and whichDay <= 7: #"M-Su"
            x = QCheckBox()
            x.setMaximumWidth(myMaxWidth)
            #byte 1 tells us how to fill in the days of the week
            ########################################
#            if self.getBit(b0, whichDay) == 1:
#                x.setChecked(True)
            ########################################    
            if self.getBit(b0, whichDay+1) == 1:
                x.setChecked(True)
            ########################################    
        if whichDay == 8: #"Time"
            x = QTimeEdit()
            x.setMaximumWidth(myMaxWidth2)
            #byte 2 tells us how to fill in the hour. and byte 3 the minute.
            x.setTime(QTime(b1,b2))
        if whichDay == 9: #"Type"
            x = QComboBox()
            x.addItem("Open")
            x.addItem("Middle")
            x.addItem("Close")
            x.setMaximumWidth(myMaxWidth2)
            #byte 3 tells us if it is an open or close operation
            if b3 == 0:
                x.setCurrentIndex(0)
            else:
                x.setCurrentIndex(1)
        if whichDay >= 10 and whichDay <= 13: #"Bytes 0-3"
            x = QLabel()
            if whichDay == 10: #byte 0
                x.setText(str(b0))
            if whichDay == 11: #byte 1
                x.setText(str(b1))
            if whichDay == 12: #byte 2
                x.setText(str(b2))
            if whichDay == 13: #byte 3
                x.setText(str(b3))
            x.setMaximumWidth(myMaxWidth3)
            x.setMinimumWidth(45)
            tempQL.setLayoutDirection(Qt.RightToLeft)
            x.setLayoutDirection(Qt.RightToLeft)
        x.setMaximumHeight(myMaxHeight)
        x.setObjectName(dayName.strip() + "_" + str(timestampCounter))
        
        if whichDay >= 1:
            x.setEnabled(enabled)
        def miniAndyClick():
            self.allOtherClicks(x.objectName())
        self.connect(x, SIGNAL("clicked()"), miniAndyClick)
        self.connect(x, SIGNAL("timeChanged(QTime)"), miniAndyClick)
        self.connect(x, SIGNAL("currentIndexChanged(int)"), miniAndyClick)
        miniVLayout.addWidget(tempQL)
        miniVLayout.addWidget(x)
        return miniVLayout
    #--------------Get a "week module"------------------
    def getWeekModule(self, timestampCounter, byte1=0, byte2=0, byte3=0, byte4=0, enabled=False):
        myWeek = QHBoxLayout() #horizontal layout
        for i in range(14):
            myWeek.addItem(self.getDayModule(timestampCounter,i,byte1,byte2,byte3,byte4,enabled))
        return myWeek
    #----Deal with Submit button click (save to file, send to microcontroller)---- 
    def submitButtonClicked(self):
        #figure out stuff to write
        stuffToWrite = self.getDescription() + "\n"
        for i in range(0,100):
            tempChild = self.findChild(QCheckBox, name="Enabled_"+str(i))
            if tempChild == None:
                break
            else: #the row exists...
                if(tempChild.isChecked()): #and the row is enabled...
                    stuffToWrite += self.findChild(QLabel, name="Byte 0_"+str(i)).text() + ","
                    stuffToWrite += self.findChild(QLabel, name="Byte 1_"+str(i)).text() + ","
                    stuffToWrite += self.findChild(QLabel, name="Byte 2_"+str(i)).text() + ","
                    stuffToWrite += self.findChild(QLabel, name="Byte 3_"+str(i)).text() + "\n"
        #write it to file
        myFname = str(self.myWinID) + ".settings"
        with open(myFname,"w") as f:
            f.write(stuffToWrite)
            f.close()
        ########################### SEND TO MICROCONTROLLER #######################
        bigArr = ConvertTimes().convert(stuffToWrite)
        Commands().sendCurrentTime()
        time.sleep(3)
        Commands().sendNewAlarmTimes(int(self.myWinID), bigArr)
        ###########################################################################
        #send to microcontroller (DEBUGGING: output messagebox)
        message = QMessageBox()
        message.setText("Finished.\n" \
                         +"\nThe following was sent and recorded locally...\n" + stuffToWrite)
        message.addButton("Accept", QMessageBox.AcceptRole)
        message.exec_()
        #get rid of the "must save changes" warning:
        (self.findChild(QLabel, name="TitleLabel")).setText("<h2>Window Times:</h2>")
    #----------------Deal with exit click----------------
    def exitClicked(self):
        self.close()
    #----------------Get Window Description--------------
    def getDescription(self):
        if self.myWinDesc != None:
            return self.myWinDesc
        myFname = str(self.myWinID) + ".settings"
        if os.path.exists(myFname) == False:
            return "(None)"
        with open(myFname,"r") as f:
            lns = f.read()
            f.close()
        lns = lns.split("\n")
        if(len(lns) >= 1):
            self.myWinDesc = str(lns[0])
            return self.myWinDesc
        return "(None)"
    #-------Load from file (called within __init__)------
    def loadFromFile(self, vlayout):
        myFname = str(self.myWinID) + ".settings"
        timestampCounter = 0
        if os.path.exists(myFname) == True: #if the settings file exists
            with open(myFname,"r") as f:
                lns = f.read()
                f.close()
            lns = lns.split('\n')
            if(len(lns) > 1): #if there's more than 1, first is description, toss it
                lns = lns[1:]
            for ln in lns: #allow ANY number to be loaded from file...
                ln = ln.strip()
                ln = ln.split(",")
                if len(ln) == 4:
                    try:
                        i0 = int(ln[0])
                        i1 = int(ln[1])
                        i2 = int(ln[2])
                        i3 = int(ln[3])
                        vlayout.addItem(self.getWeekModule(timestampCounter,i0,i1,i2,i3,enabled=True))
                        timestampCounter += 1
                    except:
                        pass #ignore lines where parsing failed...
            #And now add some blank ones to get up to 8
        else:
            QMessageBox.warning(None,'No settings file found...','No settings file was found in the local folder.\n\nA blank template will be loaded.')
        while timestampCounter < 8:
            vlayout.addItem(self.getWeekModule(timestampCounter))
            timestampCounter += 1
    #-------Deal with all clicks------------
    def allOtherClicks(self, obName): #only called when state is changed
        xtitle = self.findChild(QLabel, name="TitleLabel")
        xtitle.setText("<h2>Window Times: <font color = \"red\" size=\"4\">(Please click \"Apply Changes\" to load new times onto window)</font></h2>")
        timestampNumStr = obName.split("_")[1]
        objectType = obName.split("_")[0]
        dayNamez1 = ["M","T","W","Th","F","Sa","Su"]
        #------If this in an Enable click, do appropriate enabling/disabling----- 
        if objectType == "Enabled": #flip state of associated objects
            newState = self.findChild(QCheckBox, name=obName).isChecked()
            for dayName in dayNamez1:
                self.findChild(QCheckBox, name=dayName+"_"+timestampNumStr).setEnabled(newState)
            self.findChild(QTimeEdit, name="Time_"+timestampNumStr).setEnabled(newState)
            self.findChild(QComboBox, name="Type_"+timestampNumStr).setEnabled(newState)
            for iii in range(4):
                self.findChild(QLabel, name="Byte "+str(iii)+"_"+timestampNumStr).setEnabled(newState)
            return
        #-----If this is a "time" click, update bytes 1 and 2
        if objectType == "Time":
            tempTimeObj = self.findChild(QTimeEdit, name=obName)
            myQTime = tempTimeObj.time() #returns a "QTime 
            #byte 1 is hour:
            (self.findChild(QLabel, name="Byte 1_"+timestampNumStr)).setText(str(myQTime.hour()))
            #byte 2 is minute:
            (self.findChild(QLabel, name="Byte 2_"+timestampNumStr)).setText(str(myQTime.minute()))
            return            
        #-----If this is an "open/close" click, update byte 3    
        if objectType == "Type":
            (self.findChild(QLabel, name="Byte 3_"+timestampNumStr)).setText(str((self.findChild(QComboBox, name=obName)).currentIndex()))
            return
        #------If this is M-F click, update byte 0
        if dayNamez1.count(objectType) >= 1:
            M_checked = int(self.findChild(QCheckBox, name="M_"+timestampNumStr).isChecked())
            T_checked = int(self.findChild(QCheckBox, name="T_"+timestampNumStr).isChecked())
            W_checked = int(self.findChild(QCheckBox, name="W_"+timestampNumStr).isChecked())
            Th_checked = int(self.findChild(QCheckBox, name="Th_"+timestampNumStr).isChecked())
            F_checked = int(self.findChild(QCheckBox, name="F_"+timestampNumStr).isChecked())
            Sa_checked = int(self.findChild(QCheckBox, name="Sa_"+timestampNumStr).isChecked())
            Su_checked = int(self.findChild(QCheckBox, name="Su_"+timestampNumStr).isChecked())
            addItUp = Su_checked + 2*M_checked + 4*T_checked + 8*W_checked
            addItUp +=  16*Th_checked + 32*F_checked + 64*Sa_checked              
            (self.findChild(QLabel, name="Byte 0_"+timestampNumStr)).setText(str(addItUp))
            return
    def changeDescClicked(self):
        myTuple = QInputDialog.getText(None,'Change Name','Please enter a Name\n(Name will be truncated to 10 characters)',QLineEdit.Normal,self.getDescription())
        if myTuple[1] == True: #user didn't hit cancel
            xtitle = self.findChild(QLabel, name="TitleLabel")
            xtitle.setText("<h2>Window Times: <font color = \"red\" size=\"4\">(Please click \"Apply Changes\" to load new times onto window)</font></h2>")
            tempDesc = myTuple[0]
            if len(tempDesc) > 30:
                tempDesc = tempDesc[0:30]            
            (self.findChild(QLabel, name="WindowNameLabel")).setText( \
             "<h2>Window Desc: <font color = \"green\" size=\"5\">&ldquo;" + tempDesc +"&rdquo;</font></h2>")
            self.myWinDesc = tempDesc
            Commands().sendWindowName(windowNumber=int(self.myWinID), windowName=self.myWinDesc)
            
    def __init__(self, parent=None, winID = None):
        super(SingleWindow, self).__init__(parent)
        self.myWinID = winID
        self.myWinDesc = None
        self.setWindowTitle("Set window change times")
        self.resize(QSize(300,500))
        vlayout = QVBoxLayout()
        vlayout.setObjectName("myVLayout")
        #-------------------------------
        #Create "Window ID" Label:
        WindowID_qlabel = QLabel()
        WindowID_qlabel.setText("<h2>Window ID: &nbsp;&nbsp;&nbsp;&nbsp; \
        <font color = \"green\" size=\"5\">"+str(winID)+"</font></h2>")
        WindowID_qlabel.setObjectName("IDLabel")
        WindowID_qlabel.setMaximumHeight(30)
        vlayout.addWidget(WindowID_qlabel)
        #Create "Window Description" Label:
        WindowName_qlabel = QLabel()
        WindowName_qlabel.setText("<h2>Window Desc: <font color = \"green\" size=\"5\">&ldquo;"+self.getDescription()+"&rdquo;</font></h2>")
        WindowName_qlabel.setObjectName("WindowNameLabel")
        WindowName_qlabel.setMaximumHeight(30)
        #Create "Change Description" Button:
        WindowDesc_button = QPushButton("Change Description")
        WindowDesc_button.setObjectName("changeDescButton")
        WindowDesc_button.setMaximumHeight(30)
        WindowDesc_button.setMaximumWidth(150)
        WindowDesc_button.setLayoutDirection(Qt.RightToLeft)
        self.connect(WindowDesc_button, SIGNAL("clicked()"), self.changeDescClicked)
        #Mini horizontal layout and add:
        minihlayout1 = QHBoxLayout()
        minihlayout1.addWidget(WindowName_qlabel)
        minihlayout1.addWidget(WindowDesc_button)
        vlayout.addItem(minihlayout1)        
        #-------------------------------
        #Add "Window Times" Label:
        Title_qlabel = QLabel()
        Title_qlabel.setText("<h2>Window Times:</h2>")
        Title_qlabel.setObjectName("TitleLabel")
        Title_qlabel.setMaximumHeight(30)
        vlayout.addWidget(Title_qlabel)
        #Load up the old times from file:
        self.loadFromFile(vlayout)
        #Add "Apply Changes" Button:
        submitButton = QPushButton("Apply Changes")
        self.connect(submitButton, SIGNAL("clicked()"), self.submitButtonClicked)
        submitButton.setMaximumWidth(140)
        submitButton.setLayoutDirection(Qt.RightToLeft)
        vlayout.addWidget(submitButton)
        #Add "Exit" Button:
        exitButton = QPushButton("Exit")
        self.connect(exitButton, SIGNAL("clicked()"), self.exitClicked)
        exitButton.setMaximumWidth(140)
        exitButton.setLayoutDirection(Qt.RightToLeft)
        vlayout.addWidget(exitButton)
        #Add spacer
        mySpacer = QLabel()
        vlayout.addWidget(mySpacer)
        #Set layout
        self.setLayout(vlayout)